package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_2_2_player extends ActorScript
{
	public var _speed:Float;
	public var _rightani:String;
	public var _leftani:String;
	public var _playernumber:Float;
	public var _scorex:Float;
	public var _scorey:Float;
	public var _up:String;
	public var _left:String;
	public var _down:String;
	public var _right:String;
	public var _spawnpointr:Region;
	public var _count:Float;
	public var _topani:Actor;
	public var _topani2:String;
	public var _bottomani:String;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("speed", "_speed");
		_speed = 0.0;
		nameMap.set("right ani", "_rightani");
		nameMap.set("left ani", "_leftani");
		nameMap.set("player number", "_playernumber");
		_playernumber = 0.0;
		nameMap.set("score x", "_scorex");
		_scorex = 0.0;
		nameMap.set("score y", "_scorey");
		_scorey = 0.0;
		nameMap.set("up", "_up");
		nameMap.set("left", "_left");
		nameMap.set("down", "_down");
		nameMap.set("right", "_right");
		nameMap.set("spawn pointr", "_spawnpointr");
		nameMap.set("count", "_count");
		_count = 0.0;
		nameMap.set("fruit", "_topani");
		nameMap.set("top ani", "_topani2");
		nameMap.set("bottom ani", "_bottomani");
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.disableRotation();
		actor.setIgnoreGravity(!false);
		if((_playernumber > Engine.engine.getGameAttribute("number of players")))
		{
			recycleActor(actor);
		}
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if((Input.swipedUp || isKeyDown(_up)))
				{
					actor.setYVelocity(-(_speed));
					actor.setAnimation("" + _topani2);
					actor.setAngle(Utils.RAD * (360));
				}
				if((Input.swipedDown || isKeyDown(_down)))
				{
					actor.setYVelocity(_speed);
					actor.setAnimation("" + _bottomani);
					actor.setAngle(Utils.RAD * (360));
				}
				if((Input.swipedLeft || isKeyDown(_left)))
				{
					actor.setXVelocity(-(_speed));
					actor.setAnimation("" + _leftani);
					actor.setAngle(Utils.RAD * (0));
				}
				if((Input.swipedRight || isKeyDown(_right)))
				{
					actor.setXVelocity(_speed);
					actor.setAnimation("" + _rightani);
					actor.setAngle(Utils.RAD * (0));
				}
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if((Engine.engine.getGameAttribute("Info") >= 100))
				{
					createRecycledActor(getActorType(10), getLastCreatedActor().getX(), getLastCreatedActor().getY(), Script.FRONT);
					recycleActor(actor);
				}
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(((Input.swipedUp || isKeyDown(_up)) || (Input.swipedDown || isKeyDown(_down))))
				{
					actor.setX((Math.floor((actor.getXCenter() / getTileWidth())) * getTileWidth()));
					actor.setXVelocity(0);
				}
			}
		});
		
		/* ======================== Actor of Type ========================= */
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && sameAsAny(getActorType(30), event.otherActor.getType(),event.otherActor.getGroup()))
			{
				for(actorInGroup in cast(getActorGroup(5), Group).list)
				{
					if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
						recycleActor(actorInGroup);
					}
				}
				for(actorInGroup in cast(getActorGroup(3), Group).list)
				{
					if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
						createRecycledActor(getActorType(24), actorInGroup.getX(), actorInGroup.getY(), Script.FRONT);
						getLastCreatedActor().setValue("mutator", "_into", actorInGroup.getType());
						recycleActor(actorInGroup);
					}
				}
				recycleActor(event.otherActor);
			}
		});
		
		/* ======================== Actor of Type ========================= */
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && sameAsAny(getActorType(24), event.otherActor.getType(),event.otherActor.getGroup()))
			{
				setGameAttribute(("" + _playernumber), ((getGameAttribute(("" + _playernumber))) + 200));
				recycleActor(event.otherActor);
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(((Input.swipedUp || isKeyDown(_left)) || (Input.swipedRight || isKeyDown(_right))))
				{
					actor.setY((Math.floor((actor.getYCenter() / getTileHeight())) * getTileHeight()));
					actor.setYVelocity(0);
				}
			}
		});
		
		/* =========================== Keyboard =========================== */
		addKeyStateListener("right", function(pressed:Bool, released:Bool, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && pressed)
			{
				createRecycledActor(getActorType(7), (actor.getX() - 3), (actor.getY() + 10), Script.FRONT);
			}
		});
		
		/* =========================== Keyboard =========================== */
		addKeyStateListener("left", function(pressed:Bool, released:Bool, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && pressed)
			{
				createRecycledActor(getActorType(7), (actor.getX() + 5), (actor.getY() + 10), Script.FRONT);
			}
		});
		
		/* =========================== Keyboard =========================== */
		addKeyStateListener("up", function(pressed:Bool, released:Bool, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && pressed)
			{
				createRecycledActor(getActorType(7), (actor.getX() + 6), (actor.getY() + 10), Script.FRONT);
			}
		});
		
		/* =========================== Keyboard =========================== */
		addKeyStateListener("down", function(pressed:Bool, released:Bool, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && pressed)
			{
				createRecycledActor(getActorType(7), (actor.getX() + 6), (actor.getY() - 5), Script.FRONT);
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}